//------------------------------------------------------------------------------------------------
//
//   SG Craft - Stargate Controller Block
//
//------------------------------------------------------------------------------------------------

package gcewing.sg;

import net.minecraft.block.*;
import net.minecraft.block.material.*;
import net.minecraft.creativetab.*;
import net.minecraft.entity.*;
import net.minecraft.entity.player.*;
import net.minecraft.tileentity.*;
import net.minecraft.world.*;

public class SGControllerBlock extends Base4WayBlock<SGControllerTE> {

	public SGControllerBlock(int id) {
		super(id, Material.rock /*SGRingBlock.ringMaterial*/, SGControllerTE.class);
		setHardness(1.5F);
		blockIndexInTexture = 0x0a;
		setCreativeTab(CreativeTabs.tabMisc);
	}
	
	@Override
	public void onBlockAdded(World world, int x, int y, int z) {
		super.onBlockAdded(world, x, y, z);
		checkForLink(world, x, y, z);
	}
	
	@Override
	public boolean canHarvestBlock(EntityPlayer player, int meta) {
		return true;
	}

//	@Override
//	public void onBlockPlacedBy(World world, int x, int y, int z, EntityLiving player) {
//		super.onBlockPlacedBy(world, x, y, z, player);
//		checkForLink(world, x, y, z);
//	}

	@Override
	public void breakBlock(World world, int x, int y, int z, int id, int data) {
		SGControllerTE cte = getTileEntity(world, x, y, z);
		if (cte == null) {
			System.out.printf("SGControllerBlock.breakBlock: No tile entity at (%d,%d,%d)\n",
				x, y, z);
				return;
		}
		if (cte.isLinkedToStargate) {
			SGBaseTE gte = cte.getLinkedStargateTE();
			if (gte != null)
				gte.clearLinkToController();
		}
	}
	
	@Override
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player,
		int side, float cx, float cy, float cz)
	{
		SGCraft.openGui(player, SGGui.SGController, world, x, y, z);
		return true;
	}
	
	public void checkForLink(World world, int x, int y, int z) {
		getTileEntity(world, x, y, z).checkForLink();
	}
	
}
